JSB.newAddon = function(mainPath){
  var newAddonClass = JSB.defineClass('AutoSymbolTransform : JSExtension', /*Instance members*/{
    //Window initialize
    sceneWillConnect: function() {
        self.webController = WebViewController.new();
    },
    //Window disconnect
    sceneDidDisconnect: function() {
    },
    //Window resign active
    sceneWillResignActive: function() {
    },
    //Window become active
    sceneDidBecomeActive: function() {
    },
    notebookWillOpen: function(notebookid) {
      NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onProcessExcerptText:','ProcessNewExcerpt');
      NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onProcessExcerptText:','ChangeExcerptRange');
      self.autosymboltransform = NSUserDefaults.standardUserDefaults().objectForKey('marginnote_autosymboltransform');
    },
    notebookWillClose: function(notebookid) {
      NSNotificationCenter.defaultCenter().removeObserverName(self,'ProcessNewExcerpt');
      NSNotificationCenter.defaultCenter().removeObserverName(self,'ChangeExcerptRange');
    },
    documentDidOpen: function(docmd5) {
    },
    documentWillClose: function(docmd5) {
    },
    controllerWillLayoutSubviews: function(controller) {
    },
    queryAddonCommandStatus: function() {
      if(Application.sharedInstance().studyController(self.window).studyMode < 3)
        return {image:'title.png',object:self,selector:'toggleAutoSymbolTransform:',checked:(self.autosymboltransform?true:false)};
      return null;
    },
    //Clicking note
    onProcessExcerptText: function(sender){
      if(!Application.sharedInstance().checkNotifySenderInWindow(sender,self.window))return;//Don't process message from other window
      if(!self.autosymboltransform)return;
      var noteid = sender.userInfo.noteid;
      var note = Database.sharedInstance().getNoteById(noteid);
      if(note && note.excerptText && note.excerptText.length > 0 && !note.groupNoteId){
        var timerCount = 0;
        NSTimer.scheduledTimerWithTimeInterval(1,true,function(timer){
          function repSymbol(s) {
            s = s.replace(/([\u4E00-\u9FA5]|^|\n|\r)([\,\.\?\!])(?=[\u4E00-\u9FA5]|$|\n|\r)/g,function(u,v,w,x) {
            sign = {
              ',': '，',
              '?': '？',
              '!': '！'
            };
            return sign[w] ? v + sign[w] : u;
            });
          return s;
          };
          var text = repSymbol(note.excerptText);
          if(text && text.length){
            UndoManager.sharedInstance().undoGrouping('AutoSymbolTransform',note.notebookId,function(){
              note.excerptText = text;
              Database.sharedInstance().setNotebookSyncDirty(note.notebookId);
            });
            NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('RefreshAfterDBChange',self,{topicid:note.notebookId});
          }
          timerCount++;
          if(timerCount >= 4){
            timer.invalidate();
          }
        });
      }
    },
    toggleAutoSymbolTransform: function(sender) {
      var lan = NSLocale.preferredLanguages().length?NSLocale.preferredLanguages()[0].substring(0,2):'en';
      if(self.autosymboltransform){
        self.autosymboltransform = false;
        if(lan == 'zh')
          Application.sharedInstance().showHUD('自动转换符号类型已关闭',self.window,2);
        else
          Application.sharedInstance().showHUD('Auto symbol transform is turned off',self.window,2);
      }
      else{
        self.autosymboltransform = true;
        if(lan == 'zh')
          Application.sharedInstance().showHUD('创建摘录后，摘录中的标点符号将自动被转换为中文类型',self.window,2);
        else
          Application.sharedInstance().showHUD('After creating an excerpt, the excerpt\'s symbol will be automatically transform to Chinese format',self.window,2);
      }
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.autosymboltransform,'marginnote_autosymboltransform');
      Application.sharedInstance().studyController(self.window).refreshAddonCommands();
    },
  }, /*Class members*/{
    addonDidConnect: function() {
    },
    addonWillDisconnect: function() {
    },
    applicationWillEnterForeground: function() {
    },
    applicationDidEnterBackground: function() {
    },
    applicationDidReceiveLocalNotification: function(notify) {
    },
  });
  return newAddonClass;
};

